/* mktemp - make a name for a temporary file */

#include <unistd.h>

static char hex[16] = "0123456789ABCDEF";

char *mktemp(char *template)
{
    char *p = template, *q;
    int pid = getpid();

    while (*p) p++;

    /* replace first four X's with hexadecimal pid */
    for (q = (p -= 2); *--p == 'X';) *p = hex[pid % 16], pid /= 16;

    /* replace last two X's with two letter sequence */
    for (p = q + 1, *p = *q = 'a'; p >= q; p--) {
	for (*p = 'a'; *p < 'z'; (*p)++)
	    if (access(template, 0) < 0) return template;
	for (*p = 'A'; *p < 'Z'; (*p)++)
	    if (access(template, 0) < 0) return template;
    }
    return 0;	/* out of names! */
}

#ifdef TEST
void main(void) {
    char *s;

    while (s = mktemp("mktempXXXXXX")) close(creat(s, 0666));
}
#endif
